<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (127)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="the-clickjacking-attack">The clickjacking attack</h1>
    <p>
      The “clickjacking” attack allows an evil page to click on a “victim site”
      <em>on behalf of the visitor</em>.
    </p>
    <p>
      Many sites were hacked this way, including Twitter, Facebook, Paypal and
      other sites. They have all been fixed, of course.
    </p>
    <h2 id="the-idea">The idea</h2>
    <p>The idea is very simple.</p>
    <p>Here’s how clickjacking was done with Facebook:</p>
    <ol type="1">
      <li>A visitor is lured to the evil page. It doesn’t matter how.</li>
      <li>
        The page has a harmless-looking link on it (like “get rich now” or
        “click here, very funny”).
      </li>
      <li>
        Over that link the evil page positions a transparent
        <code>&lt;iframe&gt;</code> with <code>src</code> from facebook.com, in
        such a way that the “Like” button is right above that link. Usually
        that’s done with <code>z-index</code>.
      </li>
      <li>
        In attempting to click the link, the visitor in fact clicks the button.
      </li>
    </ol>
    <h2 id="the-demo">The demo</h2>
    <p>
      Here’s how the evil page looks. To make things clear, the
      <code>&lt;iframe&gt;</code> is half-transparent (in real evil pages it’s
      fully transparent):
    </p>
    ```html run height=120 no-beautify
    <style>
      iframe { /* iframe from the victim site */
        width: 400px;
        height: 100px;
        position: absolute;
        top:0; left:-20px;
      *!*
        opacity: 0.5; /* in real opacity:0 */
      */!*
        z-index: 1;
      }
    </style>
    <div>Click to get rich now:</div>
    <!-- The url from the victim site -->
    <p><em>!</em> <iframe src="/clickjacking/facebook.html"></iframe></p>
    <button>Click here!</button>
    <p><em>/!</em></p>
    <div>…And you’re cool (I’m a cool hacker actually)!</div>
    <p>```</p>
    <p>The full demo of the attack:</p>
    <p>[codetabs src=“clickjacking-visible” height=160]</p>
    <p>
      Here we have a half-transparent
      <code>&lt;iframe src="facebook.html"&gt;</code>, and in the example we can
      see it hovering over the button. A click on the button actually clicks on
      the iframe, but that’s not visible to the user, because the iframe is
      transparent.
    </p>
    <p>
      Here’s the same example, but closer to reality, with
      <code>opacity:0</code> for <code>&lt;iframe&gt;</code>:
    </p>
    <p>[codetabs src=“clickjacking” height=160]</p>
    <p>
      All we need to attack – is to position the <code>&lt;iframe&gt;</code> on
      the evil page in such a way that the button is right over the link. So
      that when a user clicks the link, they actually click the button. That’s
      usually doable with CSS.
    </p>
    <p>
      ```smart header=“Clickjacking is for clicks, not for keyboard” The attack
      only affects mouse actions (or similar, like taps on mobile).
    </p>
    <p>
      Keyboard input is much difficult to redirect. Technically, if we have a
      text field to hack, then we can position an iframe in such a way that text
      fields overlap each other. So when a visitor tries to focus on the input
      they see on the page, they actually focus on the input inside the iframe.
    </p>
    <p>
      But then there’s a problem. Everything that the visitor types will be
      hidden, because the iframe is not visible.
    </p>
    <p>
      People will usually stop typing when they can’t see their new characters
      printing on the screen. ```
    </p>
    <h2 id="old-school-defences-weak">Old-school defences (weak)</h2>
    <p>
      The oldest defence is a bit of JavaScript which forbids opening the page
      in a frame (so-called “framebusting”).
    </p>
    <p>That looks like this:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="cf">if</span> (top <span class="op">!=</span> window) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="va">top</span>.<span class="at">location</span> <span class="op">=</span> <span class="va">window</span>.<span class="at">location</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      That is: if the window finds out that it’s not on top, then it
      automatically makes itself the top.
    </p>
    <p>
      This not a reliable defence, because there are many ways to hack around
      it. Let’s cover a few.
    </p>
    <h3 id="blocking-top-navigation">Blocking top-navigation</h3>
    <p>
      We can block the transition caused by changing
      <code>top.location</code> in
      <a href="info:onload-ondomcontentloaded#window.onbeforeunload"
        >beforeunload</a
      >
      event handler.
    </p>
    <p>
      The top page (enclosing one, belonging to the hacker) sets a preventing
      handler to it, like this:
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="va">window</span>.<span class="at">onbeforeunload</span> <span class="op">=</span> <span class="kw">function</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">  <span class="cf">return</span> <span class="kw">false</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="op">};</span></a></code></pre>
    </div>
    <p>
      When the <code>iframe</code> tries to change <code>top.location</code>,
      the visitor gets a message asking them whether they want to leave.
    </p>
    <p>
      In most cases the visitor would answer negatively because they don’t know
      about the iframe - all they can see is the top page, there’s no reason to
      leave. So <code>top.location</code> won’t change!
    </p>
    <p>In action:</p>
    <p>[codetabs src=“top-location”]</p>
    <h3 id="sandbox-attribute">Sandbox attribute</h3>
    <p>
      One of the things restricted by the <code>sandbox</code> attribute is
      navigation. A sandboxed iframe may not change <code>top.location</code>.
    </p>
    <p>
      So we can add the iframe with
      <code>sandbox="allow-scripts allow-forms"</code>. That would relax the
      restrictions, permitting scripts and forms. But we omit
      <code>allow-top-navigation</code> so that changing
      <code>top.location</code> is forbidden.
    </p>
    <p>Here’s the code:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">&lt;iframe</span><span class="ot"> *</span><span class="er">!*sandbox</span><span class="ot">=</span><span class="st">&quot;allow-scripts allow-forms&quot;</span><span class="er">*/!*</span><span class="ot"> src=</span><span class="st">&quot;facebook.html&quot;</span><span class="kw">&gt;&lt;/iframe&gt;</span></a></code></pre>
    </div>
    <p>There are other ways to work around that simple protection too.</p>
    <h2 id="x-frame-options">X-Frame-Options</h2>
    <p>
      The server-side header <code>X-Frame-Options</code> can permit or forbid
      displaying the page inside a frame.
    </p>
    <p>
      It must be sent exactly as HTTP-header: the browser will ignore it if
      found in HTML <code>&lt;meta&gt;</code> tag. So,
      <code>&lt;meta http-equiv="X-Frame-Options"...&gt;</code> won’t do
      anything.
    </p>
    <p>The header may have 3 values:</p>
    <dl>
      <dt><code>DENY</code></dt>
      <dd>Never ever show the page inside a frame.</dd>
      <dt><code>SAMEORIGIN</code></dt>
      <dd>
        Allow inside a frame if the parent document comes from the same origin.
      </dd>
      <dt><code>ALLOW-FROM domain</code></dt>
      <dd>
        Allow inside a frame if the parent document is from the given domain.
      </dd>
    </dl>
    <p>For instance, Twitter uses <code>X-Frame-Options: SAMEORIGIN</code>.</p>
    <pre class="online"><code>Here&#39;s the result:

```html
&lt;iframe src=&quot;https://twitter.com&quot;&gt;&lt;/iframe&gt;
```

&lt;!-- ebook: prerender/ chrome headless dies and timeouts on this iframe --&gt;
&lt;iframe src=&quot;https://twitter.com&quot;&gt;&lt;/iframe&gt;

Depending on your browser, the `iframe` above is either empty or alerting you that the browser won&#39;t permit that page to be navigating in this way.</code></pre>
    <h2 id="showing-with-disabled-functionality">
      Showing with disabled functionality
    </h2>
    <p>
      The <code>X-Frame-Options</code> header has a side-effect. Other sites
      won’t be able to show our page in a frame, even if they have good reasons
      to do so.
    </p>
    <p>
      So there are other solutions… For instance, we can “cover” the page with a
      <code>&lt;div&gt;</code> with styles
      <code>height: 100%; width: 100%;</code>, so that it will intercept all
      clicks. That <code>&lt;div&gt;</code> is to be removed if
      <code>window == top</code> or if we figure out that we don’t need the
      protection.
    </p>
    <p>Something like this:</p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode html"
      ><code class="sourceCode html"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">&lt;style&gt;</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="pp">#protector</span> {</a>
<a class="sourceLine" id="cb5-3" title="3">    <span class="kw">height</span>: <span class="dv">100</span><span class="dt">%</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-4" title="4">    <span class="kw">width</span>: <span class="dv">100</span><span class="dt">%</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-5" title="5">    <span class="kw">position</span>: <span class="dv">absolute</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-6" title="6">    <span class="kw">left</span>: <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-7" title="7">    <span class="kw">top</span>: <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-8" title="8">    <span class="kw">z-index</span>: <span class="dv">99999999</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-9" title="9">  }</a>
<a class="sourceLine" id="cb5-10" title="10"><span class="kw">&lt;/style&gt;</span></a>
<a class="sourceLine" id="cb5-11" title="11"></a>
<a class="sourceLine" id="cb5-12" title="12"><span class="kw">&lt;div</span><span class="ot"> id=</span><span class="st">&quot;protector&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb5-13" title="13">  <span class="kw">&lt;a</span><span class="ot"> href=</span><span class="st">&quot;/&quot;</span><span class="ot"> target=</span><span class="st">&quot;_blank&quot;</span><span class="kw">&gt;</span>Go to the site<span class="kw">&lt;/a&gt;</span></a>
<a class="sourceLine" id="cb5-14" title="14"><span class="kw">&lt;/div&gt;</span></a>
<a class="sourceLine" id="cb5-15" title="15"></a>
<a class="sourceLine" id="cb5-16" title="16"><span class="kw">&lt;script&gt;</span></a>
<a class="sourceLine" id="cb5-17" title="17">  <span class="co">// there will be an error if top window is from the different origin</span></a>
<a class="sourceLine" id="cb5-18" title="18">  <span class="co">// but that&#39;s ok here</span></a>
<a class="sourceLine" id="cb5-19" title="19">  <span class="cf">if</span> (<span class="va">top</span>.<span class="va">document</span>.<span class="at">domain</span> <span class="op">==</span> <span class="va">document</span>.<span class="at">domain</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-20" title="20">    <span class="va">protector</span>.<span class="at">remove</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb5-21" title="21">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-22" title="22"><span class="kw">&lt;/script&gt;</span></a></code></pre>
    </div>
    <p>The demo:</p>
    <p>[codetabs src=“protector”]</p>
    <h2 id="samesite-cookie-attribute">Samesite cookie attribute</h2>
    <p>
      The <code>samesite</code> cookie attribute can also prevent clickjacking
      attacks.
    </p>
    <p>
      A cookie with such attribute is only sent to a website if it’s opened
      directly, not via a frame, or otherwise. More information in the chapter
      <a href="info:cookie#samesite" class="uri">info:cookie#samesite</a>.
    </p>
    <p>
      If the site, such as Facebook, had <code>samesite</code> attribute on its
      authentication cookie, like this:
    </p>
    <pre><code></code></pre>
    <p>
      …Then such cookie wouldn’t be sent when Facebook is open in iframe from
      another site. So the attack would fail.
    </p>
    <p>
      The <code>samesite</code> cookie attribute will not have an effect when
      cookies are not used. This may allow other websites to easily show our
      public, unauthenticated pages in iframes.
    </p>
    <p>
      However, this may also allow clickjacking attacks to work in a few limited
      cases. An anonymous polling website that prevents duplicate voting by
      checking IP addresses, for example, would still be vulnerable to
      clickjacking because it does not authenticate users using cookies.
    </p>
    <h2 id="summary">Summary</h2>
    <p>
      Clickjacking is a way to “trick” users into clicking on a victim site
      without even knowing what’s happening. That’s dangerous if there are
      important click-activated actions.
    </p>
    <p>
      A hacker can post a link to their evil page in a message, or lure visitors
      to their page by some other means. There are many variations.
    </p>
    <p>
      From one perspective – the attack is “not deep”: all a hacker is doing is
      intercepting a single click. But from another perspective, if the hacker
      knows that after the click another control will appear, then they may use
      cunning messages to coerce the user into clicking on them as well.
    </p>
    <p>
      The attack is quite dangerous, because when we engineer the UI we usually
      don’t anticipate that a hacker may click on behalf of the visitor. So
      vulnerabilities can be found in totally unexpected places.
    </p>
    <ul>
      <li>
        It is recommended to use <code>X-Frame-Options: SAMEORIGIN</code> on
        pages (or whole websites) which are not intended to be viewed inside
        frames.
      </li>
      <li>
        Use a covering <code>&lt;div&gt;</code> if we want to allow our pages to
        be shown in iframes, but still stay safe.
      </li>
    </ul>
  </body>
</html>
